Table of Contents

NAME

SYNOPSIS

|

DESCRIPTION

The utility takes the given filename and overwrites a portion of it to create a unique filename. The may be any filename with some number of appended to it, for example If no is specified a default of is used and the flag is implied (see below). The trailing are replaced with a combination of the current process number and random letters. The name chosen depends both on the number of in the and the number of collisions with pre-existing files. The number of unique filenames can return depends on the number of provided; ten will result in testing roughly 26 ** 10 combinations. If can successfully generate a unique filename, the file (or directory) is created with file permissions such that it is only readable and writable by its owner (unless the flag is given) and the filename is printed to standard output. is provided to allow shell scripts to safely use temporary files. Traditionally, many shell scripts take the name of the program with the PID as a suffix and use that as a temporary filename. This kind of naming scheme is predictable and the race condition it creates is easy for an attacker to win. A safer, though still inferior approach is to make a temporary directory using the same naming scheme. While this does allow one to guarantee that a temporary file will not be subverted, it still allows a simple denial of service attack. For these reasons it is suggested that be used instead. The options are as follows: Print the version and exit. Make a directory instead of a file. Use the specified as a prefix when generating the temporary filename. The will be overridden by the user’s environment variable if it is set. This option implies the flag (see below). Fail silently if an error occurs. This is useful if a script does not want error output to go to standard error. Generate a path rooted in a temporary directory. This directory is chosen as follows: If the user’s environment variable is set, the directory contained therein is used. Otherwise, if the flag was given the specified directory is used. If none of the above apply, is used. In this mode, the (if specified) should be a directory component (as opposed to a full path) and thus should not contain any forward slashes. Operate in mode. The temp file will be unlinked before exits. This is slightly better than but still introduces a race condition. Use of this option is not encouraged. The utility exits with a value of 0 on success or 1 on failure.

ENVIRONMENT

directory in which to place the temporary file when in mode

EXAMPLES

The following fragment illustrates a simple use of where the script should quit if it cannot get a safe temporary file. TMPFILE=‘mktemp /tmp/example.XXXXXXXXXX‘ || exit 1 echo "program output" >> $TMPFILE The same fragment with support for a user’s environment variable can be written as follows. TMPFILE=‘mktemp -t example.XXXXXXXXXX‘ || exit 1 echo "program output" >> $TMPFILE This can be further simplified if we don’t care about the actual name of the temporary file. In this case the flag is implied. TMPFILE=‘mktemp‘ || exit 1 echo "program output" >> $TMPFILE In some cases, it may be desirable to use a default temporary directory other than In this example the temporary file will be created in unless the user’s environment variable specifies otherwise. TMPFILE=‘mktemp -p /extra/tmp example.XXXXXXXXXX‘ || exit 1 echo "program output" >> $TMPFILE In some cases, we want the script to catch the error. For instance, if we attempt to create two temporary files and the second one fails we need to remove the first before exiting. TMP1=‘mktemp -t example.1.XXXXXXXXXX‘ || exit 1 TMP2=‘mktemp -t example.2.XXXXXXXXXX‘ if [ $? -ne 0 ]; then    rm -f $TMP1
   exit 1
fi Or perhaps you don’t want to exit if is unable to create the file. In this case you can protect that part of the script thusly. TMPFILE=‘mktemp -q -t example.XXXXXXXXXX‘ && {    # Safe to use $TMPFILE in this block
   echo data > $TMPFILE
   ...
   rm -f $TMPFILE
}

SEE ALSO

HISTORY

The utility appeared in OpenBSD 2.1.


Table of Contents